image: python:3.7-buster

stages:
  - pre
  - test

pre-commit:
  stage: pre
  tags:
    - docker
  script:
    - pip install tox
    - tox -e pre-commit

pylint:
  stage: pre
  tags:
    - docker
  script:
    - pip install tox
    - tox -e pylint

validate-tool-xml:
  stage: test
  tags:
    - docker
  before_script:
    - apt update
    - apt install libxml2-utils
    - pip3 install .
  script:
    - >
      time for tool in $(cat setup.py | grep -zo "entry_points=[^}]*" | grep -oaE "^[[:blank:]]*\"[^ =\"]+ =" | grep -oE "[^ =\"]*"); do
        echo -n "testing $tool..."
        $tool --xmlhelp | xmllint --noout -
        echo "OK"
      done
